<!--
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
-->

<link rel="import" href="../polymer/polymer.html">

<!--
`<hook-dynamic-text-container>` is a custom Polymer element that resizes text to fit within a container with defined height and/or width.
Set the `desired-font-size` of text and set the height of the container element and `<hook-dynamic-text-container>` will set the font-size to fit within the container.  For use with dynamic text, especially with translations.

Example:

    <hook-dynamic-text-container 
      desired-font-size="200px"
      text="Hello World.  I hope I fit!">
    </hook-dynamic-text-container>

### Styling

The following custom properties and mixins are available for styling:

Custom property | Description | Default
----------------|-------------|----------
`--container-width` | the desired width value of container element | auto
`--container-height` | the desired height value of container element | 200px
`--text-margin` | margin value of text element | 0
`--text-padding` | padding value of text element | 20px

@element hook-dynamic-text-container
@demo demo/index.html
-->

<dom-module id="hook-dynamic-text-container">
  <template>
    <style>
      :host {
        display: block;
        
        --container-width: auto;
        --container-height: 200px;
        --text-margin: 0;
        --text-padding: 20px;       
      }

      #container {
        display: -webkit-box;
        display: -ms-flexbox;
        display: -webkit-flex;
        display: flex;
        -webkit-flex-direction: column;
            -ms-flex-direction: column;
                flex-direction: column;
        -webkit-justify-content: center;
                justify-content: center;       

        width: var(--container-width);
        height: var(--container-height);        
        margin: 0;
        padding: 0;
        
        -webkit-box-sizing: border-box;
           -moz-box-sizing: border-box;
                box-sizing: border-box;
      }

      #text {
        display: block;
        margin: var(--text-margin);
        padding: var(--text-padding);
        -webkit-box-sizing: border-box;
           -moz-box-sizing: border-box;
                box-sizing: border-box;
      }

    </style>
     
     <div id="container">
       <span id="text">{{text}}</span>
     </div> 

  </template>

  <script>

    Polymer({

      is: 'hook-dynamic-text-container',

      properties: {
        /**
        * Text to be resized
        * @type {String}
        */
        text: {
          type: String,
          value: '',
        },

         /**
       * Sets the font size value (px, em, %, etc...)
       * @type {String}
       */
        desiredFontSize: {
          type: String,
          value: '16px'
        }
      },

      ready: function() {

        this.$.text.style.fontSize = this.desiredFontSize;

      },

      attached: function() {
        this._resize();
      },

      /**
       * measures height of text element in relation to container element
       * @param maxHeight - the height of the container element
       * @param currentHeight - height of text element
       */
      _compareCurrentHeight(maxHeight, currentHeight) {
        var currentFontSizePixels = window.getComputedStyle(this.$.text).getPropertyValue('font-size');
        var currentFontSize = parseInt(currentFontSizePixels);
        
        // if height of text element is greater than
        // height of container element
        if ((currentHeight) > maxHeight) {

          // decrease font size by 1px
          currentFontSize--;

          // compare the height of text element after
          // decrease font size and run comapreCurrentHeight again
          this.$.text.style.fontSize = currentFontSize + 'px';
          this.$.text.style.lineHeight = (currentFontSize + 4) + 'px';
          currentHeight = this.$.text.getBoundingClientRect().height;
          this._compareCurrentHeight(maxHeight, currentHeight);
          
        }
      },

      /**
       * gives the text element the same width as container element
       * gets height value of container element
       * gets height value of text element
       * runs compareCurrentHeight
       */
      _resize: function() {
        this.$.text.style.width = this.$.container.getBoundingClientRect().width + "px";
        
        var boxHeight = this.$.container.getBoundingClientRect().height;
        var textHeight = this.$.text.getBoundingClientRect().height;

        this._compareCurrentHeight(boxHeight, textHeight);
      }

    });
  </script>
</dom-module>
